Description

Unlike in Unix, several routines (network and file) in Windows don't set the "errno"” variable. Yet DCMTK still asks for the value,
resulting in funny error messages such as "Error: no error"

A GetLastError() could help very much here...

Related issues:
Related to DCMTK - Feature #754: Add OFerror_condition an replace platform sp... New 2017-05-02

History

#1 - 2012-05-24 18:01 - J6rg Riesmeier

Siehe z.B. folgende Funktion in dcompat.cc:

void dcmtk_plockerr (const char *s)

{
LPVOID 1lpMsgBuf=NULL;

FormatMessage (
FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
NULL,
GetLastError(),
MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
(LPTSTR) &lpMsgBuf, 0, NULL);

if (lpMsgBuf && s)

DCMNET_ERROR (s << ": " << (const char*)lpMsgBuf);
LocalFree (1pMsgBuf) ;

#2 - 2012-05-25 12:26 - Jorg Riesmeier

Siehe auch folgenden MSDN-Eintrag zu diesem Thema: http://msdn.microsoft.com/en-us/library/windows/desktop/ms737828(v=vs.85).aspx

#3 - 2013-04-28 23:50 - Andrew Chiw

- Subject changed from Verwendung von "errno" unter Windows to Usage of "errno" in Windows

#4 - 2013-08-21 15:41 - J6rg Riesmeier
- Category set to Library and Apps
- Target version set to 3.6.2

- Module changed from alle to all

Probably, a good idea would be to add a new helper function for this purpose to OFStandard.

#5 - 2013-10-12 12:38 - JO6rg Riesmeier

- File 0002-fixed-wrong-error-message-in-dcmnet-with-win32.patch added

Atsushi Suzuki <email-address-obfuscated> sent an email with the attached patch on 2013-10-09:

1) demnet error messages are not correct in win32.
http://msdn.microsoft.com/en-us/library/windows/desktop/ms737828(v=vs.85).aspx

When network functions in dcmnet failed, error messages in their return status
(OFCondition.text()) is not correct message.

For example, when ASC_requestAssociation failed with ECONNRESET,

they says "TCP Initialization Error: no error.".

To fix this, use WSAGetLastError instead of errno in dul.cc and dulfsm.cc for win32.

#6 - 2014-10-09 11:44 - J6rg Riesmeier
See also this forum posting: http://forum.demtk.org/viewtopic.php?f=1&p=16439#p16439

Refers to WinSock function WSAGetLastError().

#7 - 2015-01-15 14:33 - Michael Onken

- Private changed from No to Yes

#8 - 2015-04-13 16:38 - Michael Onken

- Assignee set to Nikolas Goldhammer

#9 - 2015-09-22 09:12 - J6rg Riesmeier

- Private changed from Yes to No

#10 - 2017-04-21 12:28 - Jan Schlamelcher
- % Done changed from 0 to 30

#11 - 2017-04-25 14:24 - Jan Schlamelcher
- % Done changed from 30 to 70

#12 - 2017-05-02 17:01 - Jan Schlamelcher

- Status changed from New to Closed

Closed, since the remaining part of the problem has been added as a separate feature #754.

Files

0002-fixed-wrong-error-message-in-dcmnet-with-win32.patch 17.9 KB 2013-10-12 Jorg Riesmeier
